diff -Naur test-for-latech/kernel/dwcs.c testqf-for-latech/kernel/dwcs.c
--- test-for-latech/kernel/dwcs.c	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/kernel/dwcs.c	2004-06-11 07:47:23.000000000 -0400
@@ -0,0 +1,1933 @@
+/*
+ *   linux/dwcs/dwcs.c
+ *
+ *   Copyright (C) 1999 Rich West
+ *
+ *   1999-10-26 Modified by Ivan Ganev <ganev@cc.gatech.edu> (along with a
+ *              bunch of other files) to make DWCS SMP-safe.
+ */
+
+/*
+ *   DWCS kernel-loadable module.
+ */
+
+/* Required definitions. */
+#ifndef MODULE
+#define MODULE
+#endif
+#ifndef __KERNEL__
+#define __KERNEL__
+#endif
+
+/* Various required header files. */
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/types.h>
+#include <linux/fs.h>
+#include <linux/proc_fs.h>
+#include <linux/utsname.h>
+#include <linux/tqueue.h>
+#include <linux/sched.h>
+#include <linux/tty.h>
+#include <linux/unistd.h>
+#include <asm/segment.h>
+
+#include <linux/mm.h>
+#include <linux/kernel_stat.h>
+#include <linux/fdreg.h>
+#include <linux/delay.h>
+#include <linux/interrupt.h>
+#include <linux/smp_lock.h>
+#include <linux/init.h>
+
+#include <asm/io.h>
+#include <asm/uaccess.h>
+#include <asm/pgtable.h>
+#include <asm/mmu_context.h>
+#include <asm/system.h>
+
+#include <linux/timex.h>
+#include <linux/signal.h>
+
+#ifdef CONFIG_DWCS_DFS
+#include <linux/slab.h>
+#include <linux/cpufreq.h>
+#endif
+
+//#define DWCS_DEBUG_ON 1
+
+#if HZ < 200
+#define TICK_SCALE(x)	((x) >> 2)
+#elif HZ < 400
+#define TICK_SCALE(x)	((x) >> 1)
+#elif HZ < 800
+#define TICK_SCALE(x)	(x)
+#elif HZ < 1600
+#define TICK_SCALE(x)	((x) << 1)
+#else
+#define TICK_SCALE(x)	((x) << 2)
+#endif
+
+#define NICE_TO_TICKS(nice)	(TICK_SCALE(20-(nice))+1)
+
+/*
+ * GANEV: nasty bug here... definitions for idle_task and can_schedule
+ *        depend ALOT on whether we're an SMP kernel or not...
+ */
+#ifdef CONFIG_SMP
+#define idle_task(cpu) (init_tasks[cpu_number_map(cpu)])
+#define can_schedule(p,cpu)	((p)->cpus_runnable & \
+				(p)->cpus_allowed & (1 << cpu))
+#else
+#define idle_task(cpu) (&init_task)
+#define can_schedule(p,cpu) (1)
+#endif
+
+#define LIMIT (PAGE_SIZE-80)   /* Set limit on amount of data in /proc/dwcs. */
+
+MODULE_AUTHOR("Georgia Tech -- CoC");
+MODULE_DESCRIPTION("DWCS Scheduler");
+MODULE_LICENSE("GPL");
+
+/* Prototypes. */
+int init_module(void);
+void cleanup_module(void);
+void my_printk(char *string);
+void (*_dummy_update_utilization)(void);
+void (*_dummy_request_admission)(void);
+
+extern void (*DWCS_scheduler)(struct task_struct **, struct task_struct **);
+void DWCS_schedule(struct task_struct **, struct task_struct **);
+void do_update_utilization(int flag, struct task_struct *tptr);
+int DWCS_request_admission(struct task_struct *tptr,struct dwcs_sched_param *param);
+
+extern void *sys_call_table[];
+extern int DWCS_module_loaded;
+extern struct list_head runqueue_head;
+extern int DWCS_update_utilization;
+extern int utilization;
+extern int nr_running;
+extern unsigned long volatile jiffies_sim;
+//#ifdef CONFIG_QFABRIC
+extern int DWCS_admission_control;
+extern int call_admission_control(struct task_struct *, struct sched_param *);
+//#endif
+
+/* Power saving related definitions */
+#define DWCS_EM_NORMAL                0x00000000 /* No DFS,DVS done by dwcs */
+#define DWCS_EM_AVERAGE_CONSERVATIVE  0x00000001 /* Averaging proc. speed without missed deadlines */
+#define DWCS_EM_AVERAGE_AGGRESSIVE    0x00000002 /* Averaging proc. speed with max missed deadlines */
+#define DWCS_EM_ADAPTIVE_CONSERVATIVE 0x00000003 /* Individual proc. speed without missed deadlines */
+#define DWCS_EM_ADAPTIVE_AGGRESSIVE   0x00000004 /* Individual proc. speed with max missed deadlines */
+int energy_mode; /* Initially non power saving mode */
+int reserved_utilization = MAX_UTILIZATION / 10; /* How much of MAX_UTILIZATION should be reserved for non DWCS proc. */
+int av_cons_utilization(void); /* Calculates the utilization if no deadline is missed */
+int av_aggr_utilization(void); /* Calculates the utilization with max possible missed deadlines */
+int ad_cons_utilization(void);
+int ad_aggr_utilization(void);
+
+#ifdef CONFIG_DWCS_DFS
+#define DWCS_MODE_VMI 0
+#define DWCS_MODE_THEORETICAL 1
+#endif
+#define MAX_PER (unsigned long)999999
+unsigned int start_time;
+struct task_struct *dwcs_hyper_period_task = NULL;
+unsigned long int dwcs_hyper_period_old_violations = 0;
+unsigned long int dwcs_hyper_period_old_misses = 0;
+unsigned long int dwcs_hyper_period_old_idles = 0;
+unsigned long int dwcs_hyper_period_violations = 0;
+unsigned long int dwcs_hyper_period_misses = 0;
+unsigned long int dwcs_hyper_period_idles = 0;
+int dwcs_hyper_period_task_iterations = 0;
+int dwcs_hyper_period_task_count = 0;
+static int hyper_period_recalc_needed = 0;
+#ifdef CONFIG_DWCS_DFS
+void set_slowest_cpuspeed(struct task_struct *); /* Sets cpu to slowest speed possible */
+
+#ifdef CONFIG_ARCH_ADIFCC
+#define get_80200_CCLKCFG(out)   asm volatile("mrc P14, 0, %0, c6, c0, 0" : \
+                                                  "=r"(out))
+#define set_80200_CCLKCFG(val)   asm volatile("mcr P14, 0, %0, c6, c0, 0" : \
+                                                  : "r"(val))
+#endif
+
+#ifdef CONFIG_ARCH_SA1100
+int current_sa1100_freq;
+unsigned int sa1100_freq[12] = {59000, 73700, 88500, 103200, 118000, 132700, 147500, 162200, 176900, 191700, 206400, 221200};
+#endif
+#endif
+
+/* Variable to determine which mode the scheduler is running in */
+int DWCS_module_mode;
+
+/* Needed for delayed runqueue insertion */
+static int first_dwcs_task = 1;
+#ifdef CONFIG_DWCS_DFS
+struct proc_dir_entry *proc_dwcs_dfs;
+struct proc_dir_entry *proc_dwcs_mode;
+struct proc_dir_entry *proc_freq_entry;
+#endif
+
+struct proc_dir_entry *proc_dwcs_dir;
+struct proc_dir_entry *proc_dwcs_enabled;
+struct proc_dir_entry *proc_dwcs_info;
+struct proc_dir_entry *proc_dwcs_energy_mode;
+struct proc_dir_entry *proc_dwcs_control;
+#ifdef DWCS_DEBUG_ON
+struct proc_dir_entry *proc_dwcs_debug_control;
+struct proc_dir_entry *proc_dwcs_debug_write;
+struct proc_dir_entry *proc_time;
+
+extern unsigned long dwcs_timer_max_time;
+extern long dwcs_max_counter;
+extern long dwcs_pid;
+extern unsigned long dwcs_sched_max_time;
+
+int DWCS_DEBUG;
+char *debug_area;
+int deb_pos;
+int debug_count;
+#endif
+
+
+#ifdef SIM_MODE
+#define JIFFIES jiffies_sim
+#else
+#define JIFFIES jiffies
+#endif
+
+#define DWCS_SERVICED_THIS_PERIOD 0x10000000
+
+
+/*
+ * Careful!
+ *
+ * This has to add the process to the _beginning_ of the
+ * run-queue, not the end. See the comment about "This is
+ * subtle" in the scheduler proper..
+ */
+static inline void add_to_runqueue(struct task_struct * p)
+{
+	list_add(&p->run_list, &runqueue_head);
+	nr_running++;
+}
+
+static inline void move_last_runqueue(struct task_struct * p)
+{
+	list_del(&p->run_list);
+	list_add_tail(&p->run_list, &runqueue_head);
+}
+
+static inline void move_first_runqueue(struct task_struct * p)
+{
+	list_del(&p->run_list);
+	list_add(&p->run_list, &runqueue_head);
+}
+
+#ifdef CONFIG_DWCS_DFS
+/* Resets cpu to default clockrate */
+void set_default_cpuspeed(void)
+{
+#ifdef CONFIG_ARCH_ADIFCC
+	set_80200_CCLKCFG(9);
+#endif
+#ifdef CONFIG_ARCH_SA1100
+	cpufreq_set (sa1100_freq[10]);
+#endif
+}
+#endif
+
+#ifdef CONFIG_DWCS_DFS
+/* Calculates real clockrate and changes cpu register */
+void do_set_slowest_cpuspeed(int speedup)
+{
+#ifdef CONFIG_ARCH_ADIFCC
+	int clockrate = 733;
+	clockrate = clockrate * 100 / speedup;
+	if (clockrate < 400)
+		set_80200_CCLKCFG(4);
+	else if (clockrate < 466)
+		set_80200_CCLKCFG(5);
+	else if (clockrate < 533)
+		set_80200_CCLKCFG(6);
+	else if (clockrate < 600)
+		set_80200_CCLKCFG(7);
+	else if (clockrate < 666)
+		set_80200_CCLKCFG(8);
+	else
+		set_80200_CCLKCFG(9);
+#endif
+#ifdef CONFIG_ARCH_SA1100
+	int clockrate = 206;
+	clockrate = clockrate * 100 / speedup;
+	if (clockrate < 59)
+		cpufreq_set (sa1100_freq[0]);
+	else if (clockrate < 73)
+		cpufreq_set (sa1100_freq[1]);
+	else if (clockrate < 88)
+		cpufreq_set (sa1100_freq[2]);
+	else if (clockrate < 103)
+		cpufreq_set (sa1100_freq[3]);
+	else if (clockrate < 118)
+		cpufreq_set (sa1100_freq[4]);
+	else if (clockrate < 132)
+		cpufreq_set (sa1100_freq[5]);
+	else if (clockrate < 147)
+		cpufreq_set (sa1100_freq[6]);
+	else if (clockrate < 162)
+		cpufreq_set (sa1100_freq[7]);
+	else if (clockrate < 176)
+		cpufreq_set (sa1100_freq[8]);
+	else if (clockrate < 191)
+		cpufreq_set (sa1100_freq[9]);
+	else if (clockrate < 207)
+		cpufreq_set (sa1100_freq[10]);
+	else 
+		cpufreq_set (sa1100_freq[11]);
+#endif
+}
+#endif
+
+#ifdef CONFIG_DWCS_DFS
+static int clk2mhz (int n) 
+{
+	switch(n) {
+		case 4 : return 400;
+		case 5 : return 466;
+		case 6 : return 533;
+		case 7 : return 600;
+		case 8 : return 666;
+		case 9 : return 733;
+		default: return -1;
+	}
+
+	return 400;
+}
+#endif
+
+static unsigned long euclid (unsigned long m, unsigned long n) 
+{
+	unsigned long r;
+
+	r = m % n;
+	if (!r) {
+		return n;
+	}
+	return euclid (n, r);
+}
+
+static unsigned long least_common_period (unsigned long x, unsigned long y)
+{
+	return ((x * y) / euclid (x, y));	
+}
+
+static int find_smallest (unsigned long *period, int size)
+{
+	int i;
+	int index = -1;
+	unsigned long smallest = MAX_PER;
+
+	for (i = 0; i < size; i++) {
+		if (period[i] < smallest) {
+			index = i;
+			smallest = period[i];
+		}
+	}
+
+	return index;
+}
+
+static void find_hyper_period_task (int flag)
+{
+	int i;
+	int lcp;
+	unsigned long largest_period;
+	unsigned long *period;
+	int dwcs_task_count;
+	int smallest_index;
+	struct task_struct *temp;
+
+	dwcs_hyper_period_task = NULL;
+	dwcs_task_count = 0;
+	largest_period = 0;
+	for_each_task (temp) {
+	    if ((flag == 1) && (current == temp)) {
+	    } else {
+		if ((temp->dwcs_params->deadline != (unsigned long)-1) && 
+			((int)temp->dwcs_params->period > 0)) {
+			dwcs_task_count++;
+			if ((int)temp->dwcs_params->period > largest_period) {
+				dwcs_hyper_period_task = temp;
+				largest_period = temp->dwcs_params->period;
+			}
+		}
+	    }
+	}
+
+   	if (dwcs_task_count == 0) {
+		printk (KERN_DEBUG "No Hyper Period Task\n");
+		first_dwcs_task = 1;
+		hyper_period_recalc_needed = 0;
+		return;
+	}
+
+	if (dwcs_task_count == 1)
+		start_time = jiffies;
+
+	period = kmalloc (dwcs_task_count * sizeof (unsigned long), GFP_KERNEL);
+	for (i = 0; i < dwcs_task_count; i++)
+		period[i] = MAX_PER;
+	i = 0;
+	for_each_task (temp) {
+		if ((temp->dwcs_params->deadline != (unsigned int)-1) && 
+			((int)temp->dwcs_params->period > 0)) {
+			period[i] = temp->dwcs_params->period;
+			i++;
+		}
+	}
+
+	lcp = 1;
+	for (i = 0; i < dwcs_task_count; i++) {
+		smallest_index = find_smallest (period, dwcs_task_count);
+		lcp = least_common_period (lcp, period[smallest_index]);
+		period[smallest_index] = MAX_PER;
+	}
+
+	dwcs_hyper_period_task_iterations = lcp / largest_period;
+	dwcs_hyper_period_task_count = 0;
+	
+	printk (KERN_DEBUG "Hyper Task PID = %d\tLeast Common Period = %d\n", dwcs_hyper_period_task->pid, lcp);
+
+	kfree (period);
+
+	hyper_period_recalc_needed = 0;
+}
+
+
+#ifdef CONFIG_DWCS_DFS
+void dwcs_dfs_measurements (struct task_struct *p)
+{
+	int misses;
+	int violations;
+	int idles;
+	static int freq_change;
+	volatile unsigned int cclkcfg;
+	siginfo_t si;
+
+	misses = dwcs_hyper_period_misses - dwcs_hyper_period_old_misses;
+	violations = dwcs_hyper_period_violations - dwcs_hyper_period_old_violations;
+	idles = dwcs_hyper_period_idles - dwcs_hyper_period_old_idles;
+
+	freq_change = 0;
+
+#ifdef CONFIG_ARCH_ADIFCC
+	if (violations > 0) {
+		get_80200_CCLKCFG(cclkcfg);
+		if (cclkcfg < 9) {
+			cclkcfg++;
+			if (cclkcfg > 9)
+				cclkcfg = 9;
+			set_80200_CCLKCFG(cclkcfg);
+			freq_change = 1;
+		}
+	} else if ((misses > 0) && (violations == 0)) {
+	} else if ((violations == 0) && (misses == 0)) {
+		get_80200_CCLKCFG(cclkcfg);
+		if (cclkcfg > 4) {
+			cclkcfg--;
+			set_80200_CCLKCFG(cclkcfg);
+			freq_change = 1;
+		}
+	}
+#endif
+#ifdef CONFIG_ARCH_SA1100
+	if ((violations > 0) || (idles < 1)) {
+		if (current_sa1100_freq < 11) {
+			current_sa1100_freq++;
+			si.si_signo = SIGUSR1;
+			si.si_errno = 0;
+			si.si_code = SI_KERNEL;
+			send_sig_info(SIGUSR1, &si, p);
+			//cpufreq_set (sa1100_freq[current_sa1100_freq]);
+			freq_change = 1;
+		}	
+	} else if ((misses == 0) && (violations == 0) && (idles > 0)) {
+		if (current_sa1100_freq > 0) {
+			current_sa1100_freq++;
+			si.si_signo = SIGUSR1;
+			si.si_errno = 0;
+			si.si_code = SI_KERNEL;
+			send_sig_info(SIGUSR2, &si, p);
+			current_sa1100_freq--;
+			//cpufreq_set (sa1100_freq[current_sa1100_freq]);
+			freq_change = 1;
+		}
+	}	
+#endif
+
+	if (freq_change) {
+		printk (KERN_DEBUG "%lu\t %d\t %d\t %d\t %d\t %d\n", 
+				jiffies - start_time, clk2mhz(cclkcfg), violations, 
+				misses, idles, utilization);
+	}
+						
+	dwcs_hyper_period_old_violations = dwcs_hyper_period_violations;
+	dwcs_hyper_period_old_idles = dwcs_hyper_period_idles;
+	dwcs_hyper_period_old_misses = dwcs_hyper_period_misses;
+
+}
+#endif
+
+
+#ifdef CONFIG_DWCS_DFS
+void dwcs_dfs_theoretical (void)
+{
+#ifdef CONFIG_ARCH_ADIFCC
+	unsigned int freq_matrix[6][6] = {{1000,  857,  749,  666,  599,  545},
+			    	 	  {1166, 1000,  874,  777,  699,  636},
+			    	 	  {1333, 1142, 1000,  888,  799,  727},
+			    	 	  {1500, 1285, 1125, 1000,  899,  818},
+			    	 	  {1666, 1428, 1250, 1111, 1000,  909},
+			    	 	  {1832, 1570, 1373, 1221, 1099, 1000}};
+	volatile unsigned int cclkcfg;
+#endif
+#ifdef CONFIG_ARCH_SA1100
+	unsigned int freq_matrix[12][12] = {
+		{1000,  792,  649,  552,  480,  425,  381,  343,  314,  289,  268,  268},
+		{1262, 1000,  820,  697,  606,  536,  481,  433,  396,  365,  339,  339},
+		{1538, 1219, 1000,  850,  739,  654,  587,  528,  483,  445,  413,  413},
+		{1809, 1433, 1175, 1000,  869,  769,  690,  621,  568,  524,  486,  486},
+		{2080, 1648, 1351, 1149, 1000,  884,  793,  714,  653,  602,  559,  559},
+		{2352, 1863, 1528, 1299, 1130, 1000,  897,  807,  739,  681,  632,  632},
+		{2621, 2077, 1703, 1448, 1260, 1114, 1000,  899,  823,  759,  704,  704},
+		{2913, 2308, 1893, 1609, 1400, 1238, 1111, 1000,  915,  844,  783,  783},
+		{3182, 2521, 2067, 1758, 1529, 1353, 1213, 1092, 1000,  922,  855,  855},
+		{3451, 2734, 2242, 1907, 1659, 1467, 1316, 1184, 1084, 1000,  928,  928},
+		{3719, 2947, 2416, 2055, 1787, 1581, 1418, 1276, 1168, 1077, 1000, 1000},
+		{3719, 2947, 2416, 2055, 1787, 1581, 1418, 1276, 1168, 1077,  999, 1000}};
+
+#endif
+
+	
+	int i;
+	int closest_freq = -1;
+	int smallest_difference;
+	int current_freq;
+	int k_entries;
+
+	if (hyper_period_recalc_needed) {
+		find_hyper_period_task(0);
+	}
+
+	smallest_difference = MAX_UTILIZATION;
+
+#ifdef CONFIG_ARCH_SA1100
+	current_freq = 11;
+	k_entries = 12;
+#endif
+#ifdef CONFIG_ARCH_ADIFCC
+	current_freq = 5;
+	k_entries = 6;
+#endif
+	
+	for (i = 0; i < k_entries; i++) {
+		int temp_utilization;
+		 
+		temp_utilization = (utilization * freq_matrix[current_freq][i]);
+		temp_utilization = temp_utilization / 1000;
+		temp_utilization = (MAX_UTILIZATION - reserved_utilization) - temp_utilization;
+		if ((temp_utilization >= 0) && (temp_utilization < smallest_difference)) {
+			smallest_difference = temp_utilization;
+			closest_freq = i;
+		}
+		printk (KERN_DEBUG "U = %d\t M = %d\t TU = %d\t SD = %d\n", utilization, freq_matrix[current_freq][i],
+				temp_utilization, smallest_difference);
+	}
+
+	if (closest_freq > 0) {
+#ifdef CONFIG_ARCH_ADIFCC
+		closest_freq += 4;
+		get_80200_CCLKCFG(cclkcfg);
+		if ((unsigned)closest_freq != cclkcfg) {
+			cclkcfg = (unsigned) closest_freq;
+			set_80200_CCLKCFG (cclkcfg);
+			printk (KERN_DEBUG "%ld\t %ld\n", JIFFIES - start_time, clk2mhz (cclkcfg));
+		}
+#endif
+#ifdef CONFIG_ARCH_SA1100
+		if (cpufreq_get(0) != sa1100_freq[closest_freq]) {
+			cpufreq_set (sa1100_freq[closest_freq]);
+		}
+#endif
+	}
+
+	return;
+}
+#endif
+
+#ifdef CONFIG_DWCS_DFS
+/* calculates max. possible slowdown and calls do_set_slowest_cpuspeed */
+void set_slowest_cpuspeed(struct task_struct *p)
+{
+	int max_slowdown;
+	max_slowdown = 100 * (p->dwcs_params->deadline - JIFFIES) / p->dwcs_params->service_time;
+	if (max_slowdown < p->dwcs_params->cpu_speedup) {
+		p->dwcs_params->cpu_speedup = max_slowdown;
+	}
+	do_set_slowest_cpuspeed(p->dwcs_params->cpu_speedup);
+}
+#endif
+
+static int proc_dwcs_enabled_read (char *page, char **start, off_t off,
+				   int count, int *eof, void *data)
+{
+  int len;
+  MOD_INC_USE_COUNT;
+  len = sprintf(page, "%d\n", DWCS_module_loaded);
+  MOD_DEC_USE_COUNT;
+  return len;
+}
+
+static int proc_dwcs_enabled_write (struct file *file, const char *buffer,
+				    unsigned long count, void *data)
+{
+	unsigned char value;
+	MOD_INC_USE_COUNT;
+
+	if (copy_from_user(&value, buffer, 1)) {
+		MOD_DEC_USE_COUNT;
+		return -EFAULT;
+	}
+
+	if (value == '0') {
+		DWCS_module_loaded = 0;
+		printk (KERN_DEBUG "Disabling DWCS!\n");
+	}
+	else if (value == '1') {
+		DWCS_module_loaded = 1;
+		printk (KERN_DEBUG "Enabling DWCS!\n");
+	}
+
+	MOD_DEC_USE_COUNT;
+
+	return 1;
+}
+
+#ifdef CONFIG_DWCS_DFS
+static int proc_dwcs_mode_read (char *page, char **start, off_t off, int count, 
+		int *eof, void *data)
+{
+	int len;
+
+	MOD_INC_USE_COUNT;
+	len = sprintf(page, "%d\n", DWCS_module_mode);
+	MOD_DEC_USE_COUNT;
+
+	return len;
+}
+
+static int proc_dwcs_mode_write (struct file *file, const char *buffer, unsigned long
+		counter, void *data)
+{
+	unsigned char value;
+	
+	MOD_INC_USE_COUNT;
+	if (copy_from_user(&value, buffer, 1)) {
+		MOD_DEC_USE_COUNT;
+		return -EFAULT;
+	}
+
+	if (value == '0') {
+		DWCS_module_mode = DWCS_MODE_VMI;
+		printk (KERN_DEBUG "DWCS mode now VMI!\n");
+		find_hyper_period_task(0);
+	} else if (value == '1') {
+		DWCS_module_mode = DWCS_MODE_THEORETICAL;
+		printk (KERN_DEBUG "DWCS mode now theoretical!\n");
+		dwcs_dfs_theoretical();
+	}
+
+	MOD_DEC_USE_COUNT;
+
+	return 1;
+}
+#endif
+
+#ifdef DWCS_DEBUG_ON
+static int proc_dwcs_debug_c_read(char *page, char **start, off_t off,				  int count, int *eof, void *data){
+  int len;
+  MOD_INC_USE_COUNT;
+  len = sprintf(page, "%d\n", DWCS_DEBUG);
+  MOD_DEC_USE_COUNT;
+  return len;
+}
+
+static int proc_dwcs_debug_c_write(struct file *file, const char *buffer, unsigned long count, void *data){
+  unsigned char value;
+  MOD_INC_USE_COUNT;
+
+  if(copy_from_user(&value, buffer, 1)){
+    MOD_DEC_USE_COUNT;
+    return -EFAULT;
+  }
+  if(value == '0'){
+    if(DWCS_DEBUG == 1){
+      kfree(debug_area);
+    }
+    DWCS_DEBUG = 0;
+    printk("Disabling verbose debugging!\n");
+  }
+  else if(value == '1'){
+      DWCS_DEBUG = 1;
+      deb_pos = 0;
+      debug_count = 0;
+      debug_area = (char *)kmalloc(50*sizeof(char *)*100, GFP_KERNEL);
+      memset(debug_area, '\0', sizeof(debug_area));
+      printk("Enabling verbose debugging!\n");
+  }
+
+  MOD_DEC_USE_COUNT;
+
+  return 1;
+}
+
+int proc_dwcs_debug_info_read(char *buf, char **start, off_t offset, int len, int *eof, void *data){
+  len = 0;
+  len += sprintf(buf+len,  "pid   deadline   current time   period   own   owd   cwn   cwd   flags   ready_time   service_time   time_serviced   wlate   late   on_time   violation\n");
+  /* len += sprintf(buf+len, "%s\n", debug_area); */
+  len += strlen(strncat(buf+len, debug_area, 500*100*sizeof(char *)));
+  memset(debug_area, '\0', sizeof(debug_area));
+  debug_count = 0;
+  return len;
+}
+
+int proc_time_read(char *buf, char **start, off_t offset, int len, int *eof, void *data){
+  len = 0;
+  len += sprintf(buf+len, "pid %ld\ntimer time %lu\ncounter %lu\nsched %lu\n", dwcs_pid, dwcs_timer_max_time, dwcs_max_counter, dwcs_sched_max_time);
+  dwcs_sched_max_time = 0;
+  return len;
+}
+#endif
+		  
+int proc_dwcs_info_read (char *buf, char **start, off_t offset, int len,
+			 int *eof, void *data)
+{
+
+	struct list_head *tmp;
+	struct task_struct * p;
+
+	len = 0;
+
+	len += sprintf (buf+len, "  pid name     deadline   period     own   "
+			"owd   cwn   cwd   viols      late       on-time    "
+			"flags srv-time(x10mS) state\n");
+	list_for_each(tmp, &runqueue_head) {
+		p = list_entry(tmp, struct task_struct, run_list);
+		if (len > LIMIT)
+			return len;
+
+		len += sprintf (buf+len,
+				"%5d %-8.8s %-10ld %-10ld %-5d %-5d %-5d %-5d "
+				"%-10lu %-10lu %-10lu %-5x %-15lu %-5ld\n",
+				p->pid,
+				p->comm,
+				p->dwcs_params->deadline,
+				p->dwcs_params->period,
+				p->dwcs_params->own,
+				p->dwcs_params->owd,
+				p->dwcs_params->cwn,
+				p->dwcs_params->cwd,
+				p->dwcs_params->violations,
+				p->dwcs_params->late,
+				p->dwcs_params->on_time,
+				p->dwcs_params->flags,
+				p->dwcs_params->service_time,
+				p->state);
+	}
+	return len;
+}
+
+#ifdef CONFIG_DWCS_DFS
+static int proc_dwcs_dfs_read (char *page, char **start, off_t off,
+					int count, int *eof, void *data)
+{
+	int len;
+#ifdef CONFIG_ARCH_ADIFCC
+	volatile unsigned int cclkcfg = 0;
+#endif
+	
+	MOD_INC_USE_COUNT;
+#ifdef CONFIG_ARCH_ADIFCC
+	get_80200_CCLKCFG(cclkcfg);
+	len = sprintf (page, "\tFreq.level = %d\n\tMisses = %ld\n\tViolations = %ld\n\tIdles = %ld\n\tUtilization = %d\n", 
+			cclkcfg, 
+			dwcs_hyper_period_misses, dwcs_hyper_period_violations, 
+			dwcs_hyper_period_idles, utilization);
+#endif
+#ifdef CONFIG_ARCH_SA1100
+	len = sprintf (page, "\tFreq.level = %d\n\tFrequency=%d\n\tMisses = %ld\n\tViolations = %ld\n\tIdles = %ld\n\tUtilization = %d\n", 
+			current_sa1100_freq, (int)sa1100_freq[current_sa1100_freq],
+			dwcs_hyper_period_misses, dwcs_hyper_period_violations, 
+			dwcs_hyper_period_idles, utilization);
+
+#endif
+	MOD_DEC_USE_COUNT;
+	return len;
+}
+#endif
+
+
+static int proc_dwcs_energy_mode_read (char *page, char **start, off_t off,
+				       int count, int *eof, void *data)
+{
+	int len;
+	MOD_INC_USE_COUNT;
+	len = sprintf(page, "%d\n", energy_mode);
+	MOD_DEC_USE_COUNT;
+	return len;
+}
+
+static int proc_dwcs_energy_mode_write (struct file *file, const char *buffer,
+					unsigned long count, void *data)
+{
+	unsigned char value;
+	MOD_INC_USE_COUNT;
+
+	if (copy_from_user(&value, buffer, 1)) {
+		MOD_DEC_USE_COUNT;
+		return -EFAULT;
+	}
+
+	if ((value >= '0') && (value < '5')) {
+		energy_mode = value - '0';
+		printk (KERN_DEBUG "Changed DWCS energy mode to %d!\n", energy_mode);
+	}
+
+	MOD_DEC_USE_COUNT;
+
+	return 1;
+}
+
+static int proc_dwcs_control_read(struct file *file, char *buf, size_t nbytes,
+				  loff_t *ppos)
+{
+	int len, left;
+	char msg[255];
+
+	MOD_INC_USE_COUNT;
+	len = sprintf(msg, "%s", "This node provides an ioctl to read and set the schedule parameters of processes using dwcs\n");
+
+	if (!access_ok(VERIFY_WRITE, buf, len)) {
+		MOD_DEC_USE_COUNT;
+		return -EINVAL;
+	}
+
+	left = len - *ppos;
+	if (nbytes > left) nbytes = left;
+	if (nbytes == 0) {
+		MOD_DEC_USE_COUNT;
+		return 0;
+	}
+	if (copy_to_user(buf, msg + *ppos, nbytes)) {
+		MOD_DEC_USE_COUNT;
+		return -EFAULT;
+	}
+
+	MOD_DEC_USE_COUNT;
+	*ppos += nbytes;
+	return nbytes;
+}
+
+static void runqueue_insert (struct dwcs_sched_param sp, int first_dwcs_process)
+{
+	struct task_struct *p;
+
+
+	if (sp.pid < 0)
+		goto runqueue_out_nounlock;
+
+	/*
+	 * We play safe to avoid deadlocks.
+	 */
+	read_lock_irq(&tasklist_lock);
+	spin_lock(&runqueue_lock);
+
+	p = find_task_by_pid(sp.pid);
+
+	if ((DWCS_module_loaded) && (DWCS_admission_control)) {
+		if (DWCS_request_admission(p, &sp) < 0)
+			goto runqueue_out_unlock;
+	}
+
+	if (!p)
+		goto runqueue_out_unlock;
+	if (sp.policy < 0)
+		sp.policy = p->policy;
+	else {
+		if (sp.policy != SCHED_FIFO && sp.policy != SCHED_RR &&
+		    sp.policy != SCHED_OTHER && sp.policy != SCHED_DWCS)
+			goto runqueue_out_unlock;
+	}
+
+		/* Begin of DWCS specific handling */
+	if (sp.policy == SCHED_DWCS) {
+		/* --CP--
+		 * Set flag for computation of utilization.
+		 */
+		DWCS_update_utilization = 1;
+
+		/* Check ranges of scheduling parameters. */
+		/* The following should never be true, since `own' and `owd'
+		 * are `unsigned'. */
+		if ((sp.own < 0) || (sp.owd < 0))
+			goto runqueue_out_unlock;
+
+		/* Restrict who can set scheduling parameters. */
+		if (!capable(CAP_SYS_NICE))
+			goto runqueue_out_unlock;
+
+		/*
+		 * --RW--
+		 * Should really set p->policy = SCHED_DWCS, so that
+		 * sched_setparam() works with DWCS. But, if we no
+		 * longer use DWCS, we need to set p->policy to SCHED_OTHER.
+		 */
+	
+		p->dwcs_params->period = sp.period;
+		p->dwcs_params->own    = sp.own;
+		p->dwcs_params->owd    = sp.owd;
+		if (sp.period == (unsigned long)-1) {
+			p->dwcs_params->deadline   = (unsigned long)-1;
+			p->dwcs_params->flags     |= DWCS_WORK_CONS;
+			p->dwcs_params->ready_time = 0;
+		}
+		else {
+			if (first_dwcs_process) {
+				p->dwcs_params->deadline   = jiffies + sp.period;
+				p->dwcs_params->ready_time = jiffies;
+			}
+			else {
+#ifdef CONFIG_DWCS_DFS
+				unsigned long new_ready_time;
+				
+	                        new_ready_time = dwcs_hyper_period_task->dwcs_params->deadline;
+	                        while ((new_ready_time - sp.period) > JIFFIES)
+		                	new_ready_time -= sp.period;
+	                        p->dwcs_params->ready_time = new_ready_time;
+	                        p->dwcs_params->deadline = new_ready_time + sp.period;
+				hyper_period_recalc_needed = 1;
+#else
+	                        p->dwcs_params->ready_time = jiffies;
+	                        p->dwcs_params->deadline = p->dwcs_params->ready_time 
+					+ sp.period;
+#endif
+			}			
+			if (sp.flags & DWCS_WORK_CONS)
+				p->dwcs_params->flags   |= DWCS_WORK_CONS;
+			else
+				p->dwcs_params->flags   &= ~DWCS_WORK_CONS;
+		}
+
+		if (sp.flags & DWCS_NON_PREEMPTIVE)
+			p->dwcs_params->flags |= DWCS_NON_PREEMPTIVE;
+		else if (sp.flags == 0) 
+			p->dwcs_params->flags &= ~(DWCS_WORK_CONS | DWCS_NON_PREEMPTIVE);
+
+		p->dwcs_params->service_time = sp.service_time;
+		p->dwcs_params->cwn          = sp.own;
+		p->dwcs_params->cwd          = sp.owd;
+
+		if (task_on_runqueue(p))
+			move_first_runqueue(p);
+		current->need_resched = 1;
+			
+
+		goto runqueue_out_unlock;
+	}
+	/* End of DWCS specific handling */
+
+	/*
+	 * Valid priorities for SCHED_FIFO and SCHED_RR are 1..99, valid
+	 * priority for SCHED_OTHER is 0.
+	 */
+	if (sp.sched_priority < 0 || sp.sched_priority > 99)
+		goto runqueue_out_unlock;
+	if ((sp.policy == SCHED_OTHER) != (sp.sched_priority == 0))
+		goto runqueue_out_unlock;
+
+	if ((sp.policy == SCHED_FIFO || sp.policy == SCHED_RR) && !capable(CAP_SYS_NICE))
+		goto runqueue_out_unlock;
+	if ((current->euid != p->euid) && (current->euid != p->uid) && !capable(CAP_SYS_NICE))
+		goto runqueue_out_unlock;
+
+	p->policy = sp.policy;
+	p->rt_priority = sp.sched_priority;
+	if (task_on_runqueue(p))
+		move_first_runqueue(p);
+
+	current->need_resched = 1;
+runqueue_out_unlock:
+	spin_unlock(&runqueue_lock);
+	read_unlock_irq(&tasklist_lock);
+
+runqueue_out_nounlock:
+	return;
+}
+
+static int proc_dwcs_control_ioctl(struct inode *inode, struct file *file, 
+				   unsigned int cmd, unsigned long arg)
+{
+	struct dwcs_sched_param sp;
+	struct task_struct *p;
+	int retval = 0;
+
+
+	switch (_IOC_NR(cmd)) {
+	case 0: /* return the schedule parameters for given pid */
+		retval = -EFAULT;
+		if (copy_from_user(&sp, (unsigned long *)arg, 
+			sizeof(struct dwcs_sched_param)))
+			goto out_nounlock_0;
+		retval = -EINVAL;
+		if (sp.pid < 0)
+			goto out_nounlock_0;
+		/*
+		 * We play safe to avoid deadlocks.
+		 */
+		read_lock_irq(&tasklist_lock);
+		spin_lock(&runqueue_lock);
+		p = find_task_by_pid(sp.pid);
+
+		if (!p)
+			goto out_unlock_0;
+
+		sp.policy = p->policy;
+		sp.sched_priority = p->rt_priority;
+		sp.period = p->dwcs_params->period;
+		sp.own = p->dwcs_params->own;
+		sp.owd = p->dwcs_params->owd;
+		sp.flags = p->dwcs_params->flags;
+		sp.service_time = p->dwcs_params->service_time;
+
+		copy_to_user((unsigned long *)arg, &sp, sizeof(struct dwcs_sched_param));
+
+		retval = 0;
+
+out_unlock_0:
+		spin_unlock(&runqueue_lock);
+		read_unlock_irq(&tasklist_lock);
+
+out_nounlock_0:
+		return retval;
+
+
+	case 1: 
+		if(copy_from_user(&sp, (unsigned long *)arg, 
+			sizeof(struct dwcs_sched_param)))
+			return -EINVAL;	
+
+		if (first_dwcs_task) {
+			runqueue_insert(sp, 1);
+			find_hyper_period_task(0);
+			first_dwcs_task = 0;
+			return 0;
+		}
+		else {
+			read_lock_irq(&tasklist_lock);
+			p = find_task_by_pid(sp.pid);
+			if ((p) && (p->dwcs_params->period != (unsigned long)-1)) {
+				printk (KERN_DEBUG "Task exists! Update parameters!\n");
+				p->dwcs_params->period = sp.period;
+				p->dwcs_params->own = sp.own;
+				p->dwcs_params->owd = sp.owd;
+				p->dwcs_params->flags = sp.flags;
+				p->dwcs_params->service_time = sp.service_time;
+				spin_unlock(&runqueue_lock);
+				read_unlock_irq(&tasklist_lock);
+
+				do_update_utilization(0, NULL);
+				find_hyper_period_task(0);
+			} else {
+				read_unlock_irq(&tasklist_lock);
+				printk(KERN_DEBUG "New task...\n");
+				runqueue_insert(sp, 0);
+			}
+	
+			return 0;
+		}
+
+	default:
+		return -ENOIOCTLCMD;
+	}
+}
+
+static struct file_operations proc_dwcs_control_operations = {
+	read:	proc_dwcs_control_read,
+	ioctl:	proc_dwcs_control_ioctl,
+};
+
+#ifdef CONFIG_DWCS_DFS
+static int proc_read_freq(char *page, char **start, off_t off, int count,
+	int *eof, void *data) {
+	int len;
+	int clk_rate = 0;
+#ifdef CONFIG_ARCH_ADIFCC
+	int cclkcfg = 0;
+#endif
+	
+	MOD_INC_USE_COUNT;
+#ifdef CONFIG_ARCH_SA1100
+	clk_rate = (int) cpufreq_get (0);
+#endif
+#ifdef CONFIG_ARCH_ADIFCC
+	get_80200_CCLKCFG(cclkcfg);
+	clk_rate = (int) cclkcfg;
+#endif
+	len = sprintf(page, "%d\n", clk_rate);
+	MOD_DEC_USE_COUNT;
+
+	return len;
+}
+
+static int proc_write_freq(struct file *file, const char *buffer,
+	unsigned long count, void *data) {
+	int clk_rate;
+	unsigned char kbuffer;
+	
+	MOD_INC_USE_COUNT;
+	if (copy_from_user(&kbuffer, buffer, 1)) {
+		MOD_DEC_USE_COUNT;
+		return -EFAULT;
+	}
+
+#ifdef CONFIG_ARCH_SA1100
+	if (kbuffer == '0') { clk_rate = sa1100_freq[0]; 
+		current_sa1100_freq = 0; }
+	else if (kbuffer == '1') { clk_rate = sa1100_freq[1]; 
+		current_sa1100_freq = 1; }
+	else if (kbuffer == '2') { clk_rate = sa1100_freq[2]; 
+		current_sa1100_freq = 2; }
+	else if (kbuffer == '3') { clk_rate = sa1100_freq[3]; 
+		current_sa1100_freq = 3; }
+	else if (kbuffer == '4') { clk_rate = sa1100_freq[4]; 
+		current_sa1100_freq = 4; }
+	else if (kbuffer == '5') { clk_rate = sa1100_freq[5]; 
+		current_sa1100_freq = 5; }
+	else if (kbuffer == '6') { clk_rate = sa1100_freq[6]; 
+		current_sa1100_freq = 6; }
+	else if (kbuffer == '7') { clk_rate = sa1100_freq[7]; 
+		current_sa1100_freq = 7; }
+	else if (kbuffer == '8') { clk_rate = sa1100_freq[8]; 
+		current_sa1100_freq = 8; }
+	else if (kbuffer == '9') { clk_rate = sa1100_freq[9]; 
+		current_sa1100_freq = 9; }
+	else if (kbuffer == 'A') { clk_rate = sa1100_freq[10]; 
+		current_sa1100_freq = 10; }
+	else if (kbuffer == 'B') { clk_rate = sa1100_freq[11]; 
+		current_sa1100_freq = 11; }
+	else {	
+		MOD_DEC_USE_COUNT;
+		return 1;
+	}
+	printk (KERN_DEBUG "[IPAQ-FREQ] Frequency now %d KHz!\n", clk_rate);
+	cpufreq_set((unsigned int) clk_rate);
+#endif
+#ifdef CONFIG_ARCH_ADIFCC
+	if (kbuffer == '4') { clk_rate = 4;
+	} else if (kbuffer == '5') { clk_rate = 5; 
+	} else if (kbuffer == '6') { clk_rate = 6; 
+	} else if (kbuffer == '7') { clk_rate = 7; 
+	} else if (kbuffer == '8') { clk_rate = 8; 
+	} else if (kbuffer == '9') { clk_rate = 9; 
+	} else {
+		printk("Invalid CCLKCF setting!\n");
+		MOD_DEC_USE_COUNT;
+		return 1;
+	}
+	if (clk_rate < 4 || clk_rate > 9) {
+		printk("Invalid cclkcfg setting: %d (Valid = 4,5,6,7,8,9)\n", 
+			clk_rate);
+	} else {
+		set_80200_CCLKCFG(cclkcfg);
+		get_80200_CCLKCFG(cclkcfg);
+		printk("Clock rate now %d (%d MHz)\n", cclkcfg, ((cclkcfg+2)*200)/3);
+	}
+#endif
+	MOD_DEC_USE_COUNT;
+	return 1;
+}
+#endif
+
+/* Initialize module. */
+int init_module(void)
+{
+	/* Store original dummy functions for system calls. */
+	_dummy_update_utilization    = sys_call_table[__NR_update_utilization-
+		__NR_SYSCALL_BASE];
+	_dummy_request_admission     = sys_call_table[__NR_admission_control-
+		__NR_SYSCALL_BASE];
+
+	/* Redirect  syscall table entries to the syscall fns in this module. */
+	DWCS_scheduler = DWCS_schedule;
+	sys_call_table[__NR_update_utilization-__NR_SYSCALL_BASE] = do_update_utilization;
+	sys_call_table[__NR_admission_control-__NR_SYSCALL_BASE] = DWCS_request_admission;
+	DWCS_admission_control = 1;
+
+	proc_dwcs_dir = proc_mkdir("dwcs", NULL);
+	proc_dwcs_dir->owner = THIS_MODULE;
+
+	proc_dwcs_enabled = create_proc_entry("enabled", 0644, proc_dwcs_dir);
+	proc_dwcs_enabled->owner = THIS_MODULE;
+	proc_dwcs_enabled->read_proc = proc_dwcs_enabled_read;
+	proc_dwcs_enabled->write_proc = proc_dwcs_enabled_write;
+
+	proc_dwcs_info = create_proc_read_entry("info", 0444, proc_dwcs_dir,
+						proc_dwcs_info_read, NULL);
+	proc_dwcs_info->owner = THIS_MODULE;
+
+	proc_dwcs_energy_mode = create_proc_entry("energy_mode", 0644, proc_dwcs_dir);
+	proc_dwcs_energy_mode->owner = THIS_MODULE;
+	proc_dwcs_energy_mode->read_proc = proc_dwcs_energy_mode_read;
+	proc_dwcs_energy_mode->write_proc = proc_dwcs_energy_mode_write;
+
+	proc_dwcs_control = create_proc_entry("control", 0444, proc_dwcs_dir);
+	proc_dwcs_control->owner = THIS_MODULE;
+	proc_dwcs_control->proc_fops = &proc_dwcs_control_operations;
+
+#ifdef DWCS_DEBUG_ON
+	proc_dwcs_debug_control = create_proc_entry("debugging_control", 0644,
+		proc_dwcs_dir);
+	proc_dwcs_debug_control->owner = THIS_MODULE;
+	proc_dwcs_debug_control->write_proc = proc_dwcs_debug_c_write;
+	proc_dwcs_debug_control->read_proc = proc_dwcs_debug_c_read;
+
+	proc_dwcs_debug_write = create_proc_read_entry("debug_info", 0444,
+		proc_dwcs_dir, proc_dwcs_debug_info_read, NULL);
+	proc_dwcs_debug_write->owner = THIS_MODULE;
+	proc_time = create_proc_read_entry("time", 0444, proc_dwcs_dir, proc_time_read,
+		NULL);
+	proc_time->owner = THIS_MODULE;
+#endif
+
+#ifdef CONFIG_DWCS_DFS
+	DWCS_module_mode = DWCS_MODE_VMI;
+	//DWCS_module_mode = DWCS_MODE_THEORETICAL;
+	proc_dwcs_mode = create_proc_entry("mode", 0444, proc_dwcs_dir);
+	proc_dwcs_mode->owner = THIS_MODULE;
+	proc_dwcs_mode->read_proc = proc_dwcs_mode_read;
+	proc_dwcs_mode->write_proc = proc_dwcs_mode_write;
+	proc_dwcs_dfs = create_proc_entry("dfs", 0444, proc_dwcs_dir);
+	proc_dwcs_dfs->owner = THIS_MODULE;
+	proc_dwcs_dfs->read_proc = proc_dwcs_dfs_read;
+	proc_freq_entry = create_proc_entry("cpu_freq", 0644, proc_dwcs_dir);
+	proc_freq_entry->owner = THIS_MODULE;
+	proc_freq_entry->read_proc = proc_read_freq;
+	proc_freq_entry->write_proc = proc_write_freq;
+
+#ifdef CONFIG_ARCH_SA1100
+	current_sa1100_freq = 0;
+	do {
+		if (cpufreq_get(0) == sa1100_freq[current_sa1100_freq]) break;
+		current_sa1100_freq++;
+	} while (current_sa1100_freq < 12);
+#endif
+#endif
+	DWCS_module_loaded = 1;
+
+	//if (start_khtread(send_data
+
+	return 0;
+}
+
+
+/* Remove module. */
+void cleanup_module(void)
+{
+	if (DWCS_module_loaded)
+		printk (KERN_DEBUG "Disabling DWCS!\n");
+
+	DWCS_admission_control = 0;
+	DWCS_module_loaded = 0;
+	utilization = 0;
+
+	/* Restore original dummy functions for system calls. */
+	DWCS_scheduler = NULL;
+	sys_call_table[__NR_update_utilization-__NR_SYSCALL_BASE] = 
+		_dummy_update_utilization;
+	sys_call_table[__NR_admission_control-__NR_SYSCALL_BASE] =
+		_dummy_request_admission;
+
+#ifdef DWCS_DEBUG_ON
+	if (DWCS_DEBUG) {
+		kfree(debug_area);
+	}
+	remove_proc_entry("time", proc_dwcs_dir);
+	remove_proc_entry("debug_info", proc_dwcs_dir);
+	remove_proc_entry("debugging_control", proc_dwcs_dir);
+#endif
+
+	remove_proc_entry("control", proc_dwcs_dir);
+	remove_proc_entry("energy_mode", proc_dwcs_dir);
+	remove_proc_entry("info", proc_dwcs_dir);
+	remove_proc_entry("enabled", proc_dwcs_dir);
+#ifdef CONFIG_DWCS_DFS
+	remove_proc_entry("dfs", proc_dwcs_dir);
+	remove_proc_entry("mode", proc_dwcs_dir);
+	remove_proc_entry("cpu_freq", proc_dwcs_dir);
+#endif
+	remove_proc_entry("dwcs", NULL);
+}
+
+
+/*
+ * This is the function that decides how desirable a process is..
+ * You can weigh different processes against each other depending
+ * on what CPU they've run on lately etc to try to handle cache
+ * and TLB miss penalties.
+ *
+ * Return values:
+ *	 -1000: never select this
+ *	     0: out of time, recalculate counters (but it might still be
+ *		selected)
+ *	   +ve: "goodness" value (the larger, the better)
+ *	 +1000: realtime process, select this.
+ */
+
+static inline int goodness (struct task_struct * p,
+			    int this_cpu, struct mm_struct *this_mm)
+{
+	int weight;
+
+	/*
+	 * select the current process after every other
+	 * runnable process, but before the idle thread.
+	 * Also, dont trigger a counter recalculation.
+	 */
+	weight = -1;
+	if (p->policy & SCHED_YIELD)
+		goto out;
+
+	/*
+	 * Non-RT process - normal case first.
+	 */
+	if (p->policy == SCHED_OTHER) {
+		/*
+		 * Give the process a first-approximation goodness value
+		 * according to the number of clock-ticks it has left.
+		 *
+		 * Don't do any other calculations if the time slice is
+		 * over..
+		 */
+		weight = p->counter;
+		if (!weight)
+			goto out;
+
+#ifdef CONFIG_SMP
+		/* Give a largish advantage to the same processor...   */
+		/* (this is equivalent to penalizing other processors) */
+		if (p->processor == this_cpu)
+			weight += PROC_CHANGE_PENALTY;
+#endif
+
+		/* .. and a slight advantage to the current MM */
+		if (p->mm == this_mm || !p->mm)
+			weight += 1;
+		weight += 20 - p->nice;
+		goto out;
+	}
+
+	/*
+	 * Realtime process, select the first one on the
+	 * runqueue (taking priorities within processes
+	 * into account).
+	 */
+	weight = 1000 + p->rt_priority;
+#ifdef CONFIG_QFABRIC
+	if (p->qfabric != NULL) {
+		if (p->qfabric->weight > 0) {
+			weight  = -1000;
+			p->qfabric->weight--;
+		} else
+			p->qfabric->weight = p->qfabric->orig_weight;
+	}
+#endif
+out:
+	return weight;
+}
+
+static void update_service_constraints (struct task_struct * p,
+					int check_deadlines)
+{
+
+	if (check_deadlines) {
+		while (JIFFIES > p->dwcs_params->deadline) {
+			/* printk (KERN_DEBUG "(%d) Deadline missed!\n",
+			   p->dwcs_params->cd); */
+
+#ifdef CONFIG_DWCS_DFS
+			dwcs_hyper_period_misses++;
+#endif
+			/* Statistics. */
+			p->dwcs_params->late++;
+			p->dwcs_params->wlate++;
+			if (((p->dwcs_params->on_time +
+			      p->dwcs_params->late) %
+			     p->dwcs_params->owd) == 0) {
+
+				if (p->dwcs_params->wlate > p->dwcs_params->own) {
+					p->dwcs_params->violations++;
+#ifdef CONFIG_DWCS_DFS
+					dwcs_hyper_period_violations++;
+#endif
+					/*printk (KERN_DEBUG "(%d) VIOLATION!\n",
+					  p->dwcs_params->cd);*/
+				}
+				p->dwcs_params->wlate = 0;
+			}
+
+			p->dwcs_params->deadline += p->dwcs_params->period;
+			p->dwcs_params->ready_time += p->dwcs_params->period;
+
+			if (p->dwcs_params->cwn > 0) {
+				p->dwcs_params->cwn--;
+				p->dwcs_params->cwd--;
+				if ((p->dwcs_params->cwd == 0) && (p->dwcs_params->cwn == 0)) {
+					p->dwcs_params->cwn = p->dwcs_params->own;
+					p->dwcs_params->cwd = p->dwcs_params->owd;
+				}
+			}
+			else { /* p->dwcs_params->cwn == 0. */
+				if (p->dwcs_params->owd > 0) {
+					/*
+					 * NOTE: This is not pure EDF if we got here,
+					 * since if it were, x/y = 0/0 and, therefore,
+					 * p->dwcs_params->owd = 0.
+					 *
+					 * Now, we have a window-constraint violation.
+					 * These next instructions will eventually
+					 * avoid starvation of p.
+					 */
+				/* CP: changed s.t. windowsize is always the same */
+					//p->dwcs_params->cwd++;
+					p->dwcs_params->cwd--;
+					if ((p->dwcs_params->cwd == 0) && 
+						(p->dwcs_params->cwn == 0)) {
+						p->dwcs_params->cwn = p->dwcs_params->own;
+						p->dwcs_params->cwd = p->dwcs_params->owd;
+					}
+					//p->dwcs_params->flags |= DWCS_VIOLATION;
+				}
+			}
+		}
+	}
+
+	else {
+
+		/* Service time (and time serviced) is at the resolution of
+		 * jiffies right now. That is, it is currently some multiple the
+		 * clock interrupt resolution (10mS on Intels).
+		 */
+		p->dwcs_params->time_serviced++;
+
+		/* Adjust service attributes only when a process is serviced in
+		   its entirety "on-time". */
+		if (p->dwcs_params->time_serviced == p->dwcs_params->service_time) {
+
+			if ((p->dwcs_params->cwd > p->dwcs_params->cwn) &&
+			    (p->dwcs_params->deadline  != (unsigned long)-1))
+				p->dwcs_params->cwd--;
+			/* --FS-- missing case of x == y added */
+			else if ((p->dwcs_params->cwd == p->dwcs_params->cwn) &&
+				 (p->dwcs_params->cwd > 0) &&
+				 (p->dwcs_params->deadline  != (unsigned long)-1)) {
+				p->dwcs_params->cwd--;
+				p->dwcs_params->cwn--;
+			}
+
+			if (((p->dwcs_params->cwd == 0) && (p->dwcs_params->cwn == 0)) ||
+			    (p->dwcs_params->flags & DWCS_VIOLATION)) {
+				p->dwcs_params->cwn = p->dwcs_params->own;
+				p->dwcs_params->cwd = p->dwcs_params->owd;
+				p->dwcs_params->flags &= ~DWCS_VIOLATION;
+			}
+		}
+
+		/* Disable any possible servicing of this task until its next
+		   request period if it does not support work-conservation. */
+		if ((!(p->dwcs_params->flags & DWCS_WORK_CONS)) &&
+		    (p->dwcs_params->time_serviced == p->dwcs_params->service_time))
+			p->dwcs_params->ready_time += p->dwcs_params->period;
+		else
+			if (p->dwcs_params->deadline != (unsigned long)-1) {
+				if (p->dwcs_params->time_serviced == p->dwcs_params->service_time) {
+					p->dwcs_params->flags |= DWCS_SERVICED_THIS_PERIOD;
+
+					/* The following line tells us when it's safe to
+					   reset the DWCS_SERVICED_THIS_PERIOD flag. */
+					p->dwcs_params->ready_time += p->dwcs_params->period;
+				}
+			}
+
+		if (p->dwcs_params->time_serviced == p->dwcs_params->service_time) {
+			if (p->dwcs_params->deadline != (unsigned long)-1)
+				p->dwcs_params->deadline += p->dwcs_params->period;
+#ifdef CONFIG_DWCS_DFS
+				if (p == dwcs_hyper_period_task) {
+					dwcs_hyper_period_task_count++;
+					if (dwcs_hyper_period_task_count == dwcs_hyper_period_task_iterations) {
+						if (hyper_period_recalc_needed) {
+							find_hyper_period_task(0);
+						}
+						if (DWCS_module_mode == DWCS_MODE_VMI) {
+							dwcs_dfs_measurements(p);
+						}
+						dwcs_hyper_period_task_count = 0;
+					}
+				}
+#endif
+			p->dwcs_params->time_serviced = 0;
+		}
+
+		/* Statistics. */
+		p->dwcs_params->on_time++;
+
+		if (((p->dwcs_params->on_time +
+		      p->dwcs_params->late) %
+		     p->dwcs_params->owd) == 0) {
+
+			if (p->dwcs_params->wlate > p->dwcs_params->own) {
+				p->dwcs_params->violations++;
+#ifdef CONFIG_DWCS_DFS
+				dwcs_hyper_period_violations++;
+#endif
+				/*printk (KERN_DEBUG "(%d) VIOLATION!\n",
+				  p->dwcs_params->cd);*/
+			}
+			p->dwcs_params->wlate = 0;
+		}
+
+	}
+#ifdef DWCS_DEBUG_ON
+	if (DWCS_DEBUG && (p->dwcs_params->deadline != -1) && (debug_count < 50)) {
+		char tmp[100];
+		sprintf(tmp, "%d   %ld   %ld   %ld   %d   %d   %d   %d   %d   %ld   %ld   %ld   %d   %ld   %ld   %ld\n", p->pid, p->dwcs_params->deadline, JIFFIES, p->dwcs_params->period, p->dwcs_params->own, p->dwcs_params->owd, p->dwcs_params->cwn, p->dwcs_params->cwd, p->dwcs_params->flags, p->dwcs_params->ready_time, p->dwcs_params->service_time, p->dwcs_params->time_serviced, p->dwcs_params->wlate, p->dwcs_params->late, p->dwcs_params->on_time, p->dwcs_params->violations);
+
+		strcat(debug_area, tmp);
+		debug_count++;
+	}
+#endif
+}
+
+
+struct task_struct *
+compare_service_constraints (struct task_struct * p,
+			     struct task_struct * next,
+			     struct task_struct * prev,
+			     int weight_of_p) {
+
+	if ((next->dwcs_params->flags & DWCS_NON_PREEMPTIVE) &&
+	    (next->dwcs_params->time_serviced < next->dwcs_params->service_time) &&
+	    (next->dwcs_params->time_serviced > 0))
+		return next;
+
+	if ((p->dwcs_params->ready_time > JIFFIES) &&
+	    (!(p->dwcs_params->flags & DWCS_WORK_CONS)))
+		return next;
+
+	/* In aggressive energy_mode ignore dwcs tasks handled owd-own times already */
+	if ((energy_mode == DWCS_EM_AVERAGE_AGGRESSIVE) &&
+	    (p->policy == SCHED_DWCS) &&
+	    (p->dwcs_params->cwd == p->dwcs_params->cwn))
+		return next;
+
+
+	/*
+	 * Search run queue for highest priority i.e. lowest
+	 * window-constrained, EDF task and set to `next' task for
+	 * service in the run queue.
+	 */
+
+	if ((p->dwcs_params->deadline == next->dwcs_params->deadline) &&
+	    (p->dwcs_params->deadline == (unsigned long)-1) &&
+	    (p->dwcs_params->cwn == next->dwcs_params->cwn) &&
+	    (p->dwcs_params->cwd == next->dwcs_params->cwd)) {
+
+		int this_cpu = prev->processor;
+		int weight_of_next = goodness(next, this_cpu, prev->active_mm);
+
+		/*
+		 * NOTE: For non-time-constrained tasks.
+		 *
+		 * We could've decided not do deal with `weights'. In that
+		 * case, a non-blocking process could hog the CPU even if
+		 * other processes are in the runqueue and have the same DWCS
+		 * service constraints. To be more `fair' even though we're
+		 * supposed to be real-time, we let the process that has the
+		 * largest weight have the CPU if two processes have the same DWCS
+		 * service constraints. This behaviour is in keeping with
+		 * the default Linux scheduler's behaviour.
+		 */
+		if (weight_of_p > weight_of_next)
+			next = p;
+	}
+	else {
+		/* --FS-- Moved serviced_this_period comparison to first place */
+		if ((p->dwcs_params->deadline != (unsigned long)-1) &&
+		    (!(p->dwcs_params->flags & DWCS_SERVICED_THIS_PERIOD)) &&
+		    (next->dwcs_params->flags & DWCS_SERVICED_THIS_PERIOD))
+			next = p;
+		else
+		if ((p->dwcs_params->deadline < next->dwcs_params->deadline) ||
+		    ((p->dwcs_params->deadline == next->dwcs_params->deadline) &&
+		     (p->dwcs_params->cwn * next->dwcs_params->cwd <
+		      next->dwcs_params->cwn * p->dwcs_params->cwd)) ||
+		    ((p->dwcs_params->deadline == next->dwcs_params->deadline) &&
+		     (p->dwcs_params->cwn == 0) && (next->dwcs_params->cwn == 0) &&
+		     (p->dwcs_params->cwd > next->dwcs_params->cwd)) ||
+		    ((p->dwcs_params->deadline == next->dwcs_params->deadline) &&
+		     (p->dwcs_params->cwn * next->dwcs_params->cwd ==
+		      next->dwcs_params->cwn * p->dwcs_params->cwd) &&
+		     ((p->dwcs_params->cwn > 0 && p->dwcs_params->cwd > 0)))) {
+			// ||
+		      //(p->dwcs_params->cwn < 0 && p->dwcs_params->cwd < 0)) &&
+		     //(p->dwcs_params->cwn < next->dwcs_params->cwn))) {
+			next = p;
+		}
+  }
+
+	return next;
+}
+
+int DWCS_request_admission(struct task_struct *tptr, struct dwcs_sched_param *param)
+{
+	int old_utilization;
+	int new_utilization;
+
+	new_utilization = MAX_UTILIZATION * (param->owd - param->own) \
+		* param->service_time \
+		/ (param->period * param->owd);
+	old_utilization = MAX_UTILIZATION \
+		* (tptr->dwcs_params->owd - tptr->dwcs_params->own) \
+		* tptr->dwcs_params->service_time \
+		/ (tptr->dwcs_params->period * tptr->dwcs_params->owd);
+
+	if ((new_utilization > old_utilization) &&
+	    ((utilization - old_utilization + new_utilization) > (MAX_UTILIZATION - reserved_utilization))) {
+		return -EADMISSION;
+	}
+
+	return 1;
+}
+
+/* flag = 0 (recompute all), 1 (remove task) */
+void do_update_utilization(int flag, struct task_struct *tptr)
+{
+	struct task_struct *ptr;
+
+	if (flag == 0) {
+		utilization = 0;
+		for_each_task(ptr) {
+			if (ptr->dwcs_params->period != (unsigned long)-1) {
+				utilization += MAX_UTILIZATION \
+					* (ptr->dwcs_params->owd - ptr->dwcs_params->own) \
+					* ptr->dwcs_params->service_time \
+					/ (ptr->dwcs_params->period * ptr->dwcs_params->owd);
+			}
+		}
+#ifdef CONFIG_DWCS_DFS
+		if (DWCS_module_mode == DWCS_MODE_THEORETICAL)
+			dwcs_dfs_theoretical();
+#endif
+	} else if (flag == 1) {
+		if (tptr->dwcs_params->deadline != (unsigned long)-1) {
+			find_hyper_period_task(1);
+			utilization -= MAX_UTILIZATION \
+				* (tptr->dwcs_params->owd - tptr->dwcs_params->own) \
+				* tptr->dwcs_params->service_time \
+				/ (tptr->dwcs_params->period * tptr->dwcs_params->owd);
+#ifdef CONFIG_DWCS_DFS
+			if (DWCS_module_mode == DWCS_MODE_THEORETICAL)
+				dwcs_dfs_theoretical();
+#endif
+		}
+	} 
+}
+
+int av_cons_utilization()
+{
+	int utilization = 0;
+	struct list_head *tmp;
+	struct task_struct *p;
+
+	list_for_each(tmp, &runqueue_head) {
+		p = list_entry(tmp, struct task_struct, run_list);
+		if (p->dwcs_params->period != (unsigned long)-1) {
+			utilization += MAX_UTILIZATION
+				* p->dwcs_params->service_time
+				/ p->dwcs_params->period;
+		}
+	}
+	return utilization;
+}
+
+int av_aggr_utilization()
+{
+	int utilization = 0;
+	struct list_head *tmp;
+	struct task_struct *p;
+
+	list_for_each(tmp, &runqueue_head) {
+		p = list_entry(tmp, struct task_struct, run_list);
+		if (p->dwcs_params->period != (unsigned long)-1) {
+			utilization += MAX_UTILIZATION
+				* (p->dwcs_params->owd - p->dwcs_params->own)
+				* p->dwcs_params->service_time
+				/ (p->dwcs_params->period * p->dwcs_params->owd);
+		}
+	}
+	return utilization;
+}
+
+int ad_cons_utilization()
+{
+	int utilization = 0;
+	struct list_head *tmp;
+	struct task_struct *p;
+
+	list_for_each(tmp, &runqueue_head) {
+		p = list_entry(tmp, struct task_struct, run_list);
+		if (p->dwcs_params->period != (unsigned long)-1) {
+			utilization += MAX_UTILIZATION
+				* (p->dwcs_params->service_time * p->dwcs_params->cpu_speedup / 100)
+				/ p->dwcs_params->period;
+		}
+	}
+	return utilization;
+}
+
+int ad_aggr_utilization()
+{
+	int utilization = 0;
+	struct list_head *tmp;
+	struct task_struct *p;
+
+	list_for_each(tmp, &runqueue_head) {
+		p = list_entry(tmp, struct task_struct, run_list);
+		if (p->dwcs_params->period != (unsigned long)-1) {
+			utilization += MAX_UTILIZATION
+				* (p->dwcs_params->owd - p->dwcs_params->own)
+				* (p->dwcs_params->service_time * p->dwcs_params->cpu_speedup / 100)
+				/ (p->dwcs_params->period * p->dwcs_params->owd);
+		}
+	}
+	return utilization;
+}
+
+/*
+ *  'schedule()' is the scheduler function. It's a very simple and nice
+ * scheduler: it's not perfect, but certainly works for most things.
+ *
+ * The goto is "interesting".
+ *
+ *   NOTE!!  Task 0 is the 'idle' task, which gets called when no other
+ * tasks can run. It can not be killed, and it cannot sleep. The 'state'
+ * information in task[0] is never used.
+ */
+
+void DWCS_schedule(struct task_struct **prv,
+		   struct task_struct **nxt)
+{
+	struct schedule_data * sched_data;
+	struct task_struct *prev, *next, *p;
+#ifdef CONFIG_QFABRIC
+	struct task_struct *old_p;
+#endif
+	struct list_head *tmp;
+	int this_cpu, c;
+
+#ifdef CONFIG_QFABRIC
+	asmlinkage void (*upcall_sched)(struct task_struct **,
+					struct task_struct **,
+					int *,
+					int);
+#endif
+
+	jiffies_sim++;
+
+	spin_lock_prefetch(&runqueue_lock);
+
+	BUG_ON(!current->active_mm);
+need_resched_back:
+	prev = current;
+	this_cpu = prev->processor;
+
+	if (unlikely(in_interrupt())) {
+		printk("Scheduling in interrupt\n");
+		BUG();
+	}
+
+	release_kernel_lock(prev, this_cpu);
+
+	/*
+	 * 'sched_data' is protected by the fact that we can run
+	 * only one process per CPU.
+	 */
+	sched_data = & aligned_data[this_cpu].schedule_data;
+
+	spin_lock_irq(&runqueue_lock);
+
+	/* move an exhausted RR process to be last.. */
+	if (unlikely(prev->policy == SCHED_RR))
+		if (!prev->counter) {
+			prev->counter = NICE_TO_TICKS(prev->nice);
+			move_last_runqueue(prev);
+		}
+
+	switch (prev->state) {
+	case TASK_INTERRUPTIBLE:
+		if (signal_pending(prev)) {
+			prev->state = TASK_RUNNING;
+			break;
+		}
+	default:
+		del_from_runqueue(prev);
+	case TASK_RUNNING:;
+	}
+	prev->need_resched = 0;
+
+	/*
+	 * this is the scheduler proper:
+	 */
+
+repeat_schedule:
+	/*
+	 * Default process to select..
+	 */
+	next = idle_task(this_cpu);
+	c = -1000;
+
+	if ((prev->state == TASK_RUNNING) && (prev->dwcs_params->ready_time <= JIFFIES)) {
+		prev->dwcs_params->flags &= ~DWCS_SERVICED_THIS_PERIOD;
+		c = goodness(prev, this_cpu, prev->active_mm);
+		next = prev;
+	}
+
+	/*
+	 * GANEV: update service constraints here...
+	 */
+	list_for_each(tmp, &runqueue_head) {
+		p = list_entry(tmp, struct task_struct, run_list);
+		if (can_schedule(p, this_cpu)) {
+			update_service_constraints(p, 1);
+		}
+#ifdef DWCS_DEBUG_ON
+		else if (DWCS_DEBUG && (debug_count < 50)) {
+			char tmp[100];
+			sprintf(tmp, "no csc\n%d   %ld   %ld   %ld   %d   %d   %d   %d   %d   %ld   %ld   %ld   %d   %ld   %ld   %ld\n", p->pid, p->dwcs_params->deadline, JIFFIES, p->dwcs_params->period, p->dwcs_params->own, p->dwcs_params->owd, p->dwcs_params->cwn, p->dwcs_params->cwd, p->dwcs_params->flags, p->dwcs_params->ready_time, p->dwcs_params->service_time, p->dwcs_params->time_serviced, p->dwcs_params->wlate, p->dwcs_params->late, p->dwcs_params->on_time, p->dwcs_params->violations);
+			strcat(debug_area, tmp);
+			debug_count++;
+		}
+#endif
+	}
+	if (DWCS_update_utilization == 1) {
+		do_update_utilization(0, NULL);
+		DWCS_update_utilization = 0;
+	}
+
+	list_for_each(tmp, &runqueue_head) {
+		p = list_entry(tmp, struct task_struct, run_list);
+		if (can_schedule(p, this_cpu)) {
+			int weight = goodness(p, this_cpu, prev->active_mm);
+			if (weight > c)
+				c = weight;
+			next = compare_service_constraints(p,next,prev,weight);
+		}
+	}
+#ifdef DWCS_DEBUG_ON
+/*
+	if (DWCS_DEBUG && (debug_count < 50)) {
+		char tmp[5];
+		debug_count++;
+		sprintf(tmp, "%d\n", p->pid);
+		strcat(debug_area, tmp);
+	}
+*/
+#endif
+
+#ifdef CONFIG_QFABRIC
+	if (upcall_sched_active) {
+		upcall_sched = sys_call_table[__NR_upcall_scheduler-__NR_SYSCALL_BASE];
+		old_p = next;
+		upcall_sched(&old_p, &next, &c, utilization);
+	}
+#endif
+
+	/* Do we need to re-calculate counters? */
+	if (unlikely(!c)) {
+		struct task_struct *p;
+
+		spin_unlock_irq(&runqueue_lock);
+		read_lock(&tasklist_lock);
+		for_each_task(p)
+			p->counter = (p->counter >> 1) + NICE_TO_TICKS(p->nice);
+		read_unlock(&tasklist_lock);
+		spin_lock_irq(&runqueue_lock);
+		goto repeat_schedule;
+	}
+
+	/*
+	 * from this point on nothing can prevent us from
+	 * switching to the next task, save this fact in
+	 * sched_data.
+	 */
+#ifdef CONFIG_DWCS_DFS
+	if (next == idle_task(this_cpu)) {
+		dwcs_hyper_period_idles++;
+	}
+#endif
+	sched_data->curr = next;
+	task_set_cpu(next, this_cpu);
+	spin_unlock_irq(&runqueue_lock);
+
+	update_service_constraints(next, 0);
+
+	/* --FS-- if next process is a dwcs proc. do powermgmnt */
+	/*
+	if ((next->dwcs_params->period != (unsigned long)-1) && (energy_mode != 0)){
+		int utilization = MAX_UTILIZATION;
+		if (energy_mode == DWCS_EM_AVERAGE_CONSERVATIVE) {
+			utilization = av_cons_utilization();
+		}
+		else if (energy_mode == DWCS_EM_AVERAGE_AGGRESSIVE) {
+			utilization = av_aggr_utilization();
+		}
+		if (utilization < MAX_UTILIZATION / 100)
+		  utilization = MAX_UTILIZATION / 100;
+		next->dwcs_params->cpu_speedup = (MAX_UTILIZATION - reserved_utilization) * 100 / utilization;
+#ifdef CONFIG_DWCS_DFS
+		set_slowest_cpuspeed(next);
+#endif
+	} else {
+		set_default_cpuspeed();
+	}
+*/
+
+	/* --FS-- do this check early since we can't jump to
+	 * same_process in dwcs_switch */
+	if (unlikely(prev == next) && (current->need_resched)) {
+		/* We won't go through the normal tail, so do this by hand */
+		prev->policy &= ~SCHED_YIELD;
+		goto same_process;
+	}
+
+	*prv = prev;
+	*nxt = next;
+
+	return;
+
+same_process:
+	reacquire_kernel_lock(current);
+	goto need_resched_back;
+
+}
